'''
Created on Oct 23, 2019

@author: Zuhair Hammadi
'''
from odoo import models, api

class IrModelFields(models.Model):
    _inherit = 'ir.model.fields'
    
    @api.multi
    def name_get(self):
        if self._context.get('show_field_description'):
            res = []
            for record in self:
                res.append((record.id, record.field_description))
            return res
        return super(IrModelFields, self).name_get()
        
    @api.model
    def _search(self, args, offset=0, limit=None, order=None, count=False, access_rights_uid=None):
        if self._context.get('show_field_description') and order is None:
            order = 'field_description'
        return super(IrModelFields, self)._search(args, offset=offset, limit=limit, order=order, count=count, access_rights_uid=access_rights_uid)