'''
Created on Feb 4, 2021

@author: Zuhair Hammadi
'''
from odoo import models, api

class IrRule(models.Model):
    _inherit = 'ir.rule'
    
    @api.model
    def domain_get(self, model_name, mode='read'):    
        if 'force_company' not in self._context:
            self = self.with_context(force_company = self.env.user.company_id.id)
        return super(IrRule, self).domain_get(model_name, mode = mode)
    
    def _compute_domain_keys(self):
        res = super(IrRule, self)._compute_domain_keys() or []
        res.append('force_company')
        return res