'''
Created on Oct 8, 2018

@author: Zuhair Hammadi
'''
from odoo import models, api
from odoo.exceptions import UserError

class IrSequence(models.Model):
    _inherit = 'ir.sequence'
    
    @api.model
    def next_by_code(self, sequence_code):
        res = super(IrSequence, self).next_by_code(sequence_code)
        if not res:
            company_id = self._context.get('force_company') or self.env.user.company_id.id
            company_id = self.env['res.company'].browse(company_id)
            msg="No sequence has been found for code '%s'. Please make sure a sequence is set for %s." % (sequence_code, company_id.display_name)
            raise UserError(msg)
        return res