'''
Created on Oct 2, 2018

@author: Zuhair Hammadi
'''
from odoo import models, api
from odoo.tools.safe_eval import safe_eval
from odoo.tools import pycompat

class MailMail(models.Model):
    _inherit = 'mail.mail'

    @api.model
    @api.returns('self', lambda value:value.id)
    def create(self, vals):
        if isinstance(vals.get('needaction_partner_ids') or False, pycompat.string_types):
            value = safe_eval(vals['needaction_partner_ids'])
            if value and isinstance(value, (list, tuple)):
                if all(isinstance(item, int) for item in value):
                    value = [(6,0, value)]
            vals['needaction_partner_ids'] = value
                
        return super(MailMail, self).create(vals)
        